﻿<%@ page session="true" import="com.sas.ep.sascoder.utilities.*,
		java.util.*,
		java.net.*" contentType="text/html;charset=UTF-8"%>
<%
String localeParameter = (String)request.getParameter("locale");
String sTaskGUID = (String)request.getParameter("taskGUID");
String sTestTASK = (String)request.getParameter("testTASK");
String sHost = (String)request.getParameter("HOST");
String sNotify = (String)request.getParameter("NOTIFY");
String dojoLocale = "";

String sasVersionShort = "TmpValue";
String sasOS = null;

	Locale locale = null;
	if(localeParameter != null && !"".equals(localeParameter))
	{
		// if localeParameter == lang_COUNTRY_VARIANT
		if(localeParameter.indexOf("_") > -1)
		{
			dojoLocale = localeParameter.replaceAll("_", "-").toLowerCase();
			String[] localeSplit = localeParameter.split("_");

			switch(localeSplit.length)
			{
			case 1:
				locale = new Locale(localeSplit[0]);
				break;
			case 2:
				locale = new Locale(localeSplit[0], localeSplit[1]);
				break;
			case 3:
				locale = new Locale(localeSplit[0], localeSplit[1], localeSplit[2]);
				break;
			}
		}else{//if localeParameter == lang
			dojoLocale = localeParameter.toLowerCase();
			locale = new Locale(localeParameter);
		}
	}else{
		locale = request.getLocale();
		dojoLocale = locale.toString().replaceAll("_","-").toLowerCase();
		localeParameter=locale.toString();
	}
%>

<!DOCTYPE html>
<html>
<head>
<meta http-equiv="X-UA-Compatible" content="IE=11; IE=10; IE=9; IE=EDGE" /><!-- THIS MUST BE THE FIRST TAG IN HEAD ELEMENT -->
<meta charset="UTF-8">
<meta itemprop="image" content="favicon.ico" type="image/x-icon">
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<link href="favicon.ico" rel="shortcut icon" type="image/x-icon">

<!-- SECTION 1 -->
<link media="screen" rel="stylesheet" href="resources/js/dojo/dijit/themes/corporate/css/help.css" />
<link media="screen" rel="stylesheet" href="resources/js/dojo/dijit/themes/corporate/corporate.css" />
<link media="screen" rel="stylesheet" href="resources/js/dojo/dijit/themes/corporate/css/webdms.css" />
<!--<link media="screen" rel="stylesheet" href="resources/js/com/sas/commons/controls/codeEditor/css/sce.css" /> -->
<link media="screen" rel="stylesheet" href="resources/js/dojo/dijit/themes/corporate/images/sasIcons/sasdark/sasdark_commonIcons.css" />
<link media="screen" rel="stylesheet" href="resources/js/dojo/dojox/widget/ColorPicker/ColorPicker.css" />

<!-- transfer our Java vars to JS -->
<script>
	//debugger;

	//console.log(this);
	var dojoLocale=<%=Util.getJavascriptStringLiteral(dojoLocale)%>;
	var sTaskGUID = <%=Util.getJavascriptStringLiteral(sTaskGUID)%> === "null" ? "" : <%=Util.getJavascriptStringLiteral(sTaskGUID)%>;
	var bTestTASK = <%=Util.getJavascriptStringLiteral(sTestTASK)%> === '1' ? true : false;
	var sHost = <%=Util.getJavascriptStringLiteral(sHost)%> === "null" ? "" : <%=Util.getJavascriptStringLiteral(sHost)%>;
	var bNotify = <%=Util.getJavascriptStringLiteral(sNotify)%> === "1" ? true : false;
	var sasVersionShort = <%=Util.getJavascriptStringLiteral(sasVersionShort)%>;
	var sasOS = <%=Util.getJavascriptStringLiteral(sasOS)%>;


	// globals from main.jsp, used by Mike's report thingy
	var reportApp = null;
	var reportMode = false;
	var testMode=false;
	var drillDownMode=false;
	var reportParameters=null;
	
</script>
<script type="text/javascript">
	if(dojoLocale == null || dojoLocale == 'null')
		dojoLocale=window.navigator.language; //browser locale
	dojoConfig =
	{
		async: true,
		parseOnLoad: true,
		baseUrl: 'resources/js',
		tlmSiblingOfDojo: false,
		locale: dojoLocale,
		packages: [
			{
				name:'dojo',
				location: 'dojo/dojo'
			},
			{
				name:'dgrid',
				location: 'dojo/dgrid'
			},
			{
				name:'put-selector',
				location: 'dojo/put-selector'
			},
			{
				name:'xstyle',
				location: 'dojo/xstyle'
			},
			{
				name:'dijit',
				location: 'dojo/dijit'
			},
			{
				name:'dojox',
				location: 'dojo/dojox'
			},
			{
				name: 'dojoExtensions', 
				location: 'dojoExtensions'
			},
			{
				name: 'webdms', 
				location: 'webdms'
			}
		]
	};
</script>
<script type="text/javascript" src="resources/js/dojo/dojo/dojo.js"></script>
<script type="text/javascript" src="resources/js/webdms/ctm/ctm.js" djConfig="isDebug: true, debugAtAllCosts: true, parseOnLoad: true"></script>

<!-- --------------------------------------------------------------------- -->
<!-- START: methods callable from host container (ex: EG via webBrowser control) -->
<script>
	//debugger;

	//alert("taskGUID: " + sTaskGUID);
	//alert("testTASK: " + bTestTASK);

	/* TBDeleted
	var jsShowMe = function ( sMsg ) {
		alert("Call from Host - showMe(): " + sMsg);
		// NOTE!!!!   although called in this order, the 2nd one is seen first - so calls back to C# seem to be asynchronous
		//window.external.callMe();
		//window.external.callMe2(9, 6);
	};*/

	/* TBDeleted
	var jsSetCode = function ( sCode, sParms ) {
		//alert("JSP:jsSetCode(): " + sCode + ", " + sParms );
		//alert("window: " + window );
		//alert("window.CTM: " + window.CTM );
		//alert("window.CTM.ctmSetCode(): " + window.CTM.ctmSetCode );
		window.CTM.setCodeFromHost( sCode, sParms );
	};*/

	
    // HOST -> (jsp) -> commonLoadTask()
    // Old method which will be removed in 3.7.  Here until Mike B. starts using the new jsLoadTask method.
	var jsLoadNewTask = function ( sCols, sTask, bPostEG71, json ) {
        //var jsonPackage = '{ "data" : [' + sCols + 
        //                  '], "taskID" : "' + sTask + '", "bPostEG71" : ' + bPostEG71 + 
        //                  ', "sasOS" : "WINDOWS", "userDir" : "C:\\\\Users\\\\sascel" }';

        var jsonDataObj = JSON.parse(sCols);

        var jsonObj = { "data" : [jsonDataObj], "taskID" : sTask, "sasOS" : "WINDOWS", "userDir" : "C:\\Users\\sascel" };
        var jsonString = JSON.stringify(jsonObj);

        jsLoadTask(jsonString);
	};

    
    // HOST -> (jsp) -> jsLoadTask
    //  Method to load an internal task.
    //  JSON structure:
    //      data – (required) array of default data (CAS, V9, all)
    //      taskID – (required) the identifier of the task 
    //      sasOS –  (required) operating System of SAS
    //      userDir – (required) user’s home directory
    var jsLoadTask = function (json) {
        window.CTM.ctmLoadTask(json);
    };


    // HOST -> (jsp) -> jsLoadTaskFromCTM
    //  Method to load a task from the passed in ctm/ctk xml.
    //  JSON structure:
    //      data – (required) array of default data (CAS, V9, all)
    //      sasOS –  (required) operating System of SAS
    //      userDir – (required) user’s home directory
    //  ctm – the xml blob to read in.  This can be a ctk or a ctm.  
    var jsLoadTaskFromCTM = function(json, ctm) {
        window.CTM.ctmLoadTaskFromCTM(json, ctm);
    };

	// HOST -> (jsp) -> jsCompleteCTMLoadTask()
	var jsCompleteCTMLoadTask = function(json) {
		window.CTM.jsCompleteCTMLoadTask(json);
	};

	// HOST -> (jsp) -> commonLoadTask()
    // This method is going away with 3.7.  Here until Mike B. starts calling jsLoadTaskFromCTM().
	var jsLoadTaskWithParms = function ( sCols, sParms, bPostEG71 ) {
        //var jsonPackage = '{ "data" : [' + sCols + 
        //                  '], "sasOS" : "WINDOWS", "userDir" : "C:\\\\Users\\\\sascel" }';

        var jsonDataObj = JSON.parse(sCols);

        var jsonObj = { "data" : [jsonDataObj], "sasOS" : "WINDOWS", "userDir" : "C:\\Users\\sascel" };
        var jsonString = JSON.stringify(jsonObj);

        jsLoadTaskFromCTM(jsonString, sParms);
	};

    
    // HOST -> (jsp) -> js -> CTMContentPane -> SASServerPath
    // Callback into SAS Studio with the result of the user selecting a file - ctmBrowseForFile(json)
    //  JSON structure:
    //      controlName - (required) the name of the control that this callback is for.
    //      fullPath - (required) the full path of the file selected (path + file)
    //      file - (required) just the file 
    var jsBrowseFileOK = function( json ) {
        window.CTM.jsBrowseFileOK(json);
    };

    // HOST -> (jsp) -> js -> CTMContentPane -> SASServerPath
    // Callback from the ctmFolderExists method.  Callback into SAS Studio with the result of the existence of the folder.
    //  JSON structure:
    //      controlName - (required) the name of the control which will receive the callback
    //      exists - (required) Boolean value of true or false.  
    var jsFolderExists = function( json ) {
        window.CTM.jsFolderExists(json);
    };

	// HOST -> (jsp) -> js -> CTMContentPane -> DMSTask
    // Callback from the ctmGenerateDistinctValues method.  Callback into SAS Studio with the result of the distinct values query.
    // JSON structure for the queryJSON arg:
    //      library – (required) library of the data set that was queried for distinct values
    //      member – (required) data set that was queried for distinct values
    //      dataSourceVelocityName – (required) velocity name of the data selector.  This just   needs to be passed back on the return call.  
	var jsDistinctValues = function ( values, numObs, ctrl, queryJSON, sType ) {
		// assume values is an array
		var aValues = values;

		// for EG array of values is passed via a JSON string
		if( typeof values === 'string' ) {
			aValues = dojo.fromJson( values );
		}

		window.CTM.jsDistinctValues( aValues, numObs, ctrl, queryJSON, sType );
	};

	// HOST -> (jsp) -> js -> CTMContentPane -> DMSTask
    // Callback into SAS Studio with the result of the user selecting to browse for a data set - ctmBrowseDataSet
    // JSON structure:
    //      library– (required) the name of the library the user selected when browsing for data
    //      member – (required) the name of the data set the user selected when browsing for data
    //      dataSourceVelocityName – (required) velocity name of the data selector.  Value passed back from the originating ctmBrowseDataSet call.
    //      columnsData – (required) the columns data in the same format as what is passed in ctmLoadTask.  
    //          NOTE: we only need the contents of the “data” entry of what was originally passed to us during ctmLoadData.  i.e. { “columns” : [ { “name: “Name”, “label”:””, …}]}.
	var jsBrowseDataSetOK = function( json ) {
		window.CTM.jsBrowseDataSetOK( json );
	};

    // HOST -> (jsp) -> js -> CTMContentPane -> DMSTask
    // Callback into SAS Studio with the result of a Studio data fetch - ctmFetcheDataSet
    // JSON structure:
    //      dataSourceVelocityName - (required) velocity name of the data selector.  Value passed back from the originating ctmBrowseDataSet call.
    //      columnsData - (required) the columns data in the same format as what is passed in ctmLoadTask.  
    //          NOTE: we only need the contents of the “data” entry of what was originally passed to us during ctmLoadData.  i.e. { “columns” : [ { “name: “Name”, “label”:””, …}]}.
	var jsReturnDataSet = function( json ) {
		window.CTM.jsReturnDataSet( json );
	};


	// HOST -> (jsp) -> js -> CTMContentPane -> DMSTask
    // Callback into SAS Studio with the result of the user updating the where clause of a data set- ctmValidateWhereClause
    // JSON structure:
    //      library– (required) the name of the library of the current data source
    //          NOTE: this value may be "", because it is currently unspecified
    //      member – (required) the name of the data set currently selected for the data source
    //      dataSourceVelocityName – (required) velocity name of the data selector.  Value passed back from the originating ctmValidateWhereClause call.
    //      whereClause - (required) value of the where clause that was validated.  Needs to be passed back as part of the return.
    //      hydrating - (required) whether or not this validation call originated as part of construction.  Needs to be passed back as part of the return.
    //      isValid - (required) boolean value representing whether the whereClause was valid.
	var jsValidateWhereClauseReturn = function( json ) {
		window.CTM.jsValidateWhereClauseReturn( json );
	};

	// HOST -> (jsp) -> js -> CTMContentPane -> DMSTask
	var jsResolveOutputValidation = function ( returnXML ) {
		window.CTM.jsResolveOutputValidation( returnXML );
	};

	// HOST -> (jsp) -> js -> CTMContentPane -> DMSTask
	var jsUpdateDirty = function () {
		window.CTM.jsUpdateDirty();
	};

	var jsRefresh = function () {
		window.CTM.jsRefresh();
	};
	

	/* saspfj, TBDeleted
	var jsDebugHook = function () {
		//debugger;
		var oBd = document.body;
		var oCP = dijit.byId("ctm_bc");
		//"maincontentpanetaskTabContainer_tablist"
		document.getElementById('maincontentpanetaskTabContainer_tablist').style.height=50;
		//dijit.byId("maincontentpanetaskTabContainer_tablist").resize();
	};
	*/

	// HOST -> (jsp) -> js
	var jsClearCols = function () {
		//alert("JSP:jsClearCols()");
		window.CTM.ctmClearCols();
	};

	// HOST -> (jsp) -> js
	var jsAddCols = function ( jsonString ) {
		//debugger;
		//alert("JSP:jsAddCols(): " + jsonString );
		window.CTM.ctmAddCols( jsonString );
		// once we got our data info, we're ready to load the task
		//var ctm_bc = dijit.byId("ctm_bc").startup2();
		//var ctm_bc = dijit.byId("ctm_bc");
		//ctm_bc.startup();
	};	

	// ASYNC:  HOST -> (jsp) -> js -> CTMContentPane -> DMSTask
	var jsGetTaskState = function () {
		//debugger;
		var sState = window.CTM.jsGetTaskState();
		// we return our previous value for the task state
		return sState;
	};

	// HOST -> (jsp) -> js 
	var jsGetCode = function () {
		//debugger;
		var sCode = window.CTM.jsGetCode();
		return sCode;
	};

	// ASYNC:  HOST -> (jsp) -> js
	var jsGetSessionId = function ( sBaseURL, sUser, sPassword ) {
		//debugger;
		window.CTM.getSessionId( sBaseURL, sUser, sPassword );
	};

	// HOST -> (jsp) -> js
	var jsCloseSession = function () {
		//debugger;
		window.CTM.closeSession();
	};

	// ASYNC:  HOST -> (jsp) -> js
	var jsGetTaskOutputs = function () {
		var sOutputs = window.CTM.jsGetTaskOutputs();
		// we return our previous value for the task state
		return sOutputs;
	};

	/* TBDeleted
	var jsSetTaskState = function ( sState ) {
		debugger;
		window.CTM.ctmSetTaskState( sState );
	};*/

</script>
<!-- END: methods callable from host container (ex: EG via webBrowser control) -->
<!-- --------------------------------------------------------------------- -->

</head>
<!-- xmas borders
<body class="corporate" style="margin:0 auto !important; line-height: normal !important; border:solid 3px green; width:100%; height;100%;">
	<div style="border:solid 3px red; width=100%; height=100%;" data-dojo-type="dijit/layout/ContentPane" id="ctm_bc">
	</div>
</body>
-->
<body class="corporate" style="margin:0 auto !important; line-height: normal !important; width:100%; height:100%;">
	<div style="width:100%; height:100%;" data-dojo-type="dijit/layout/ContentPane" id="ctm_bc">
	</div>
	
	<!-- saspfj, clean this and every dialog below if needed (replicated code) -->

<!-- ******************* Table Column Selector ********************** -->
<div class="dijitHidden">
<div data-dojo-type="dijit.Dialog" style="width:400px;" data-dojo-props="title:'Columns'" id="tableColumnSelector">

<table class="dijitDialogPaneContentArea"  style="padding:0px; width:100%; height:100%;overflow:hidden">

	<tr style="width:100%">
		<td height="90%" width="100%">

			<!--div dojoType="dojox.grid.DataGrid" selectionMode="extended"
					id="tableColumnSelectorGrid" style="width: 100%;height: 14em;padding-bottom: 8px"-->

			<div data-dojo-type="dijit/layout/ContentPane" id="columnSelectorGridLocation"
			     style="width: 100%; overflow:hidden">
            </div>
		</td>
	</tr>

	<tr style="width:100%">
		<td height="10%">
			<div class="dijitDialogPaneActionBar">
				<div data-dojo-type="dijit.form.Button" id="tableColumnSelectorOk" class="sasPrimaryButton">OK</div>
				<div data-dojo-type="dijit.form.Button" id="tableColumnSelectorCancel">Cancel</div>
			</div>
		</td>
	</tr>
</table>

</div>
</div>


<!-- ******************* Single Table Column Selector ********************** -->
<div class="dijitHidden">
<div data-dojo-type="dijit.Dialog" style="width:220px;height:200px;" data-dojo-props="title:'Columns'" id="singleTableColumnSelector">

<table class="dijitDialogPaneContentArea"  style="padding:0px; width:100%; height:100%;overflow:hidden">
	<tr style="width:100%">
		<td height="100%" width="100%">
			<div data-dojo-type="dijit/layout/ContentPane" id="singleColumnSelectorGridLocation"
			     style="width: 100%;height:199px;padding-bottom: 0px; overflow:hidden">
            </div>
		</td>
	</tr>
</table>

</div>
</div>
<!-- ******************* End Single Table Column Selector ********************** -->
	
</body>
</html>